#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

# --------------------------------------------------------------
# Variables
# --------------------------------------------------------------

$debug = 1;
$| = 1;

$P = "dbamon_oraap.pl";
$msgfile = "/tmp/dbamon_oraap_tmp.txt";
$verb = $ARGV[0];
$arg1 = $ARGV[1];  
$arg2 = $ARGV[2];   
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];

# Get hostname
chop($host = `hostname`);

chop($thisos = `uname`);
if    ($thisos eq "HP-UX") { $bdfcmd = "bdf";    }
elsif ($thisos eq "SunOS") { $bdfcmd = "df -k"; }
elsif ($thisos eq "Linux") { $bdfcmd = "df -k"; }
else                       { $bdfcmd = "df -k";    }
&msg("Setting bdfcmd=$bdfcmd for OS=$thisos");

# Save Company name
chop($compwork = `nslookup $host | grep Name: | awk '{ print \$2 }'`);
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];
&msg("Company: $company");

$os = $ENV{"ORACLE_SID"};
$oh = $ENV{"ORACLE_HOME"};
$os_lc = lc $os;

&msg("Starting - verb=$verb arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4");
if ($debug)
{
  &msg("ORA Env:");
  system("env | grep ORA");
}
&error("ORACLE_HOME Is Null - DBC Error or Logic Error") if $oh eq "";
&error("ORACLE_SID Is Null - DBC Error or Logic Error")  if $os eq "";

#
# Subroutines
#
#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n";
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("----------------------------------------------------------------");
  &msg("PGMERROR: $msg");
  &msg("----------------------------------------------------------------");
  &msg("Exiting");
  &msg("END_OF_PROBE");
  exit 1;
}

# ----------------------------------------------------------------------
sub checkFormsServer
# ----------------------------------------------------------------------
{
  &msg("Checking Forms Server - COMN: $comn");
  
  # Get port number
  chop($portraw = `grep serverPort $comn/html/bin/appsweb.cfg | head -1`);
  $port = (split('=',$portraw)) [1];
  &msg("Derived port=$port");

  # Count number of formsserver procs
  chop($cnt = `ps -ef | grep 'f60srvm port=$port' | grep -v grep | wc -l`);
  &msg("f60srvm Process count=$cnt");

  if ($cnt != 1)
  {
    &msg("FORMSSERVER_EXCEPTION: $cnt");
  }
  else
  {
    &msg("FORMSSERVER_OK: 0");
  }

  # Get pid of above 
  chop($fspid = `ps -ef | grep 'f60srvm port=$port' | awk '{ print \$2 }'`);

  &msg("Looking for f60webmx processes with ppid=$fspid");

  system("ps -ef  2>&1 | grep 'f60webmx' | grep ' $fspid ' | grep -v grep");
  chop($webmxcnt = `ps -ef | grep 'f60webmx webfile' | grep ' $fspid ' | grep -v grep | wc -l`);

  if ($webmxcnt < 1)
  {
    &msg("FORMSSERVERMX_EXCEPTION: $webmxcnt");
  }
  else
  {
    &msg("FORMSSERVERMX_OK: $webmxcnt");
  }  

}

# ----------------------------------------------------------------------
sub checkTCF
# ----------------------------------------------------------------------
{
  &msg("Checking TCF Status - COMN: $comn");
  if ($minproc_apache eq ".") 
  {
    &msg("TCF Status Check Disabled - DBC OracleApps_COMN_Dir: Not Specified");
    return;
  }
  $rc = system("$comn/admin/scripts/adtcfctl.sh status 2>&1");
  &msg("TCF Status Check rc=$rc ");

  if ($rc != 0)
  {
    &msg("TCFSTATUS_EXCEPTION: $rc");
  }
  else
  {
    &msg("TCFSTATUS_OK: 0");
  }
  chop($verwork = `$comn/admin/scripts/adtcfctl.sh status 2>&1 | grep 'You are running adtcfctl.sh version' | awk '{ print \$6 }'`);
  $ver = substr($verwork,0,2) . "." . substr($verwork,2);
  $ver = "" if $ver eq ".";
  &msg("VER: $ver");
}

# ----------------------------------------------------------------------
sub checkFS
# ----------------------------------------------------------------------
{
  &msg("Checking Apps Filesystems - Getting Env Vars");
  open(ENVVARS,". ~$apuser/.profile.$os_lc;env|sort|") || &error("Cannot set env for userid=$apuser"); 
  while(<ENVVARS>)
  {
    ##print;
    $var = (split("=",$_)) [0];
    chop($val = (split("=",$_)) [1]);
    $statement = "\$ORAAP_$var = '$val';";
    ##print "statement=$statement \n";
    eval $statement;
  }
  ##print "ORAAP_MSD_TOP=$ORAAP_MSD_TOP \n";

  # Check each FS that was specified in the DBC
  foreach (@fslist)
  {
    &msg("Checking Filesystem Names By DBC Entry: OraApps_FS_Check: $_");
    &runBDF($_);
  }
}

# ----------------------------------------------------------------------
sub runBDF
# ----------------------------------------------------------------------
{
  $instring = $_[0];
  $thisfs = (split("/",$instring)) [0];
  $t_warn = (split("/",$instring)) [1];
  $t_crit = (split("/",$instring)) [2];
 
  $thisvar = "ORAAP_$thisfs";

  &msg("Checking OraApps Filesystem: $thisfs - FS Name: ${$thisvar}");
  &msg("Warning Threshold: $t_warn - Critical Threshold: $t_crit ");

  if (${$thisvar} eq "")
  {
    &error("The user=$apuser environment does not contain variable $thisfs");
  }

  open(BDF, "$bdfcmd ${$thisvar} 2>&1 | tail -1 |") || &error("Error running $bdfcmd on ${$thisvar}");
  while(<BDF>)
  {
    @words = split;
    $fsname    = $words[$#words-0];   # chop to remove the percent sign
    chop($fsfullpct = $words[$#words-1]);  
    $fsunsed   = $words[$#words-2]; 
    $fsused    = $words[$#words-3];   
    $fssize    = $words[$#words-4];  
  }
  close(BDF);

  if    ($fsfullpct >= $t_crit) { $sev = "C"; }
  elsif ($fsfullpct >= $t_warn) { $sev = "W"; }
  else                          { $sev = " "; }

  &msg("FSCHECK: $thisfs $fsname $fsfullpct $fssize $fsused $sev");
}


# ----------------------------------------------------------------------
sub checkApache
# ----------------------------------------------------------------------
{
  &msg("Checking Apache Processes - Apache_Min_Proc: $minproc_apache");
  if ($minproc_apache eq ".") 
  {
    &msg("Apache Process Checking Disabled - DBC OracleApps_MinProc_Apache: Not Specified");
    $minproc_apache = 0;
  }
  chop($numproc_apache = `ps -ef | grep -v grep | grep -i $os | grep -i apache | wc -l`);
  &msg("Number of Apache Process(es) Found: $numproc_apache");

  if ($numproc_apache < $minproc_apache)
  {
    &msg("PROCCHECK_EXCEPTION: Apache $numproc_apache $minproc_apache");
  }
  else
  {
    &msg("PROCCHECK_OK: Apache $numproc_apache $minproc_apache");
  }
}

# ----------------------------------------------------------------------
sub checkListeners
# ----------------------------------------------------------------------
{
  &msg("Checking Listeners - OraApps_Forms_ORAHOME: $forms_orahome");
  if ($forms_orahome eq ".") 
  {
    &msg("Apache Listeners Checking Disabled - DBC OracleApps_Forms_ORAHOME: Not Specified");
    return;
  }

  # Check SID listener
  &msg("Checking Listener - $os");
  $rc = system("tnsping $os 2>&1");
  if ($rc != 0)
  {
    &msg("LISTENER_EXCEPTION: SID");
  }
  else
  {
    &msg("LISTENER_OK: SID");
  }

  # Check extproc
  &msg("Checking Listener - extproc_connection_data");
  $rc = system("tnsping extproc_connection_data 2>&1");
  if ($rc != 0)
  {
    &msg("LISTENER_EXCEPTION: EXTPROC");
  }
  else
  {
    &msg("LISTENER_OK: EXTPROC");
  }

  # Set 8.0 ORAHOME
  $ENV{"TNS_ADMIN"} = "$forms_orahome/network/admin";

  # Check FNDFS_sid
  &msg("Checking Listener - FNDFS_$os");
  $rc = system("tnsping FNDFS_$os 2>&1");
  if ($rc != 0)
  {
    &msg("LISTENER_EXCEPTION: FNDFS_$os");
  }
  else
  {
    &msg("LISTENER_OK: FNDFS_$os");
  }

  # Check FNDFS_host
  &msg("Checking Listener - FNDFS_$host");
  $rc = system("tnsping FNDFS_$host 2>&1");
  if ($rc != 0)
  {
    &msg("LISTENER_EXCEPTION: FNDFS_$host");
  }
  else
  {
    &msg("LISTENER_OK: FNDFS_$host");
  }
}

# ----------------------------------------------------------------------
# Main
# ----------------------------------------------------------------------

$stime = time;

#
# Check to see if Oracle is up
#
if ($verb eq "up") 
{
  &msg("Verb=up - Starting");

  # OS Stuff
  system("uname -a");
  system("model");
  system("echo 'MODE' `getconf SC_KERNEL_BITS 2>&1`");
  system("/tmp/dbamon_cpuinfo");

  $apuser         = $arg1;
  $minproc_apache = $arg2;
  $comn           = $arg3;
  $forms_orahome  = $arg4;

  for ($i=5; $i<=99999; $i++)
  {
    last if $ARGV[$i] eq "";
    push @fslist, $ARGV[$i];
  }

  &checkApache;
  &checkTCF;
  &checkFormsServer;
  &checkListeners;
  &checkFS;

  &msg("Verb=up - Done");
}

#
# Terminate
#

$etime = time;
$elapsed = $etime - $stime;
&msg("Done - Elapsed: $elapsed Seconds ");
&msg("END_OF_PROBE");
exit 0;
