#------------------------------------------------------------------------------
sub eventLog(m,h)   
#------------------------------------------------------------------------------
#
# Write header message to log file 
#
#------------------------------------------------------------------------------
{
  my ($m, $h) = @_;

  if ($debug_html) 
  {
    print "in eventLog h=$h \n";
  }

  if ($log_path eq "")
  {
    &error_msg("ERROR - SYSTEM Section variable log_path is null - exiting");
    exit 1;
  }

  $nowdate = &getdate();
  open(LOG_PATH,">>$log_path") ||  &error_msg("Cannot open append log_path=$log_path - $!");
  print LOG_PATH "\n-------$title[$h]-$nowdate-------\n";
  print LOG_PATH "$m\n"; 

  if ($h eq "") 
  {
    $h = 0;
  }

  if ($html_events_flag[$h] == 0) 
  {
    if ($debug_html) 
    {
      print "in eventLog event title h=$h\n";
    }
    open(HTML_EVENTS,">$html_events[$h]") ||  &error_msg("Cannot open output $html_path[$h] - $!");

    print HTML_EVENTS &pageHeader("Event Log for Instance: $title[$h]");

    #---- Old
    ## my $links_include = `cat /opt/dbamon/lib/trans_links.txt`;
    #---- New
    my $links_include = ""; 
    open(LI,"/opt/dbamon/lib/trans_links.txt") || &error_msg("Cannot open input trans_links - $!"); 
    while(<LI>)
    {
      $links_include .= $_; 
    }
    close(LI); 

    print HTML_EVENTS "
</table>
<div style='font-family:$www_font;font-size:10pt'>
<table width=900>
$links_include
</table>
</div>
    ";

    print HTML_EVENTS "<i><font size=1>
This page was programatically recreated by DBAmon - $nowdate</font></i>
<hr>
<!-- PlaceIndexHere -->
    ";
    $html_events_flag[$h] = 1;
  } 

  $event_log_size = ( stat "$html_events[$h]" ) [7];
  if ($event_log_size > 1000000)
  {
    &logit("log $html_events[$h] > 1mB");
    return;
  }

  open(HTML_EVENTS,">>$html_events[$h]") ||  &error_msg("Cannot open output $html_path[$h] - $!");

  $m = "$titleraw[$h] $m";

  #---- Generate unique event key
  my $event_key = int(rand(1000000));

  #---- Old
  ##print HTML_EVENTS "<hr>\n";
  ##print HTML_EVENTS "<img src='img/${e_color}ball-89.gif'> <b>$e_text Event</b>";
  #---- New
  print HTML_EVENTS "
<hr>
<a name=$event_key>
<div style='font-family:$www_font;font-size:12pt'>
<font color=${e_color}> &diams;&diams;&diams; </font>
<b>$e_text Event</b>
<font color=${e_color}> &diams;&diams;&diams; </font>
</div>
<div style='font-family:$www_font;font-size:10pt'>
<pre>
<b>[<a HREF='${dbamon_home}/errors.shtml#$e_msgid_short'>$e_msgid</a>] | $m </b> 
</pre></div>
  ";
  
  $html_events_index[$h] .= "<li>
  <samp>
    <font color=$e_color><b>$e_msgid</b></font>: 
    <a href=#$event_key><b>$m</b></a>
  </samp>
  </li>
  "; 

  push @eventdb_text,     $m;
  push @eventdb_sev,      $e_sev;
  push @eventdb_msgid,    $e_msgid_short;
  push @eventdb_instance, $h;
}

#------------------------------------------------------------------------------
1;
