# -----------------------------------------------------------------------------
sub infSaveCfg
{
  ($thishost) = @_;
  #
  # Do this only on the 1st iteration
  #

  if ($iter_count != 1 && $rootpath[$thishost] ne "")
  {
    $s_flag = "N";
    $msg = sprintf("(Not this iteration)");
    &logit($msg,$thishost);
    return;
  }

  #
  #  Save the onconfig and onstat -a output for each host
  #

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1 ;
  }
    
  &remsh("onstat -cdl", $tmpfl3, $thishost);
  ##system("cat $tmpfl3");

  if (system("grep -i 'shared memory not' $tmpfl3") == 0) 
  {
    $msg = sprintf("(down/inhibited)");
    &logit($msg,$thishost);
    return 1;
  }

  open(TMPFL3,"$tmpfl3") || &error_msg("Can't open input $tmpfl3 - $!");
  while (<TMPFL3>)
  {
    &parse;
    if ($F1 eq "ROOTPATH")   { $rootpath[$thishost] = $F2  }
    if ($F1 eq "ROOTOFFSET") { $rootoffs[$thishost] = $F2 / 2 }
  } 
  close(TMPFL3);

  &logit("DIAG rp=$rootpath[$thishost] ro=$rootoffs[$thishost]",$thishost);

  if (system("cp $tmpfl3 $save_file[$thishost]") != 0)
  {
    $msg = sprintf("Error copying onstat -a file - exiting");
    &logit($msg,$thishost);
    exit 1;
  }

  &logit("onstat -cdl Output Saved OK",$thishost);

  if ($rootpath[$thishost] eq "" || $rootoffs[$thishost] eq "")
  {
    $msg = sprintf("infSaveCfg() - %s - rootpath / rootoffs blank - ONCONFIG dbamonrc problem",$title[$thishost]);
    &logit($msg,$thishost);
    &error_msg($msg,$thishost,$tmpfl3);
    return 1;
  }
}     
# -----------------------------------------------------------------------------
1;
